c 3-D graphics
c Phase velocities, energy velocities and quality factors
c up to orthorhombic, several planes 
c
       implicit real *8 (a-h)
       implicit real *8 (o-z)
       parameter(n1=2000)
       real*4 qf1x(n1),qf1z(n1),qf2x(n1),qf2z(n1)
       real*4 aux(n1),aux1(n1),aux2(n1)
       real*4 aqx(n1),aqx1(n1)
       real*4 qf3x(n1),qf3z(n1),a1(n1),a2(n1),a3(n1)
       real*4 c1x(n1),c1z(n1),c2x(n1),c2z(n1),c3x(n1)
       real*4 c3z(n1),c1ex(n1),c1ez(n1),c2ex(n1),c2ez(n1)
       real*4 c3ex(n1),c3ez(n1),aqq1,aqq2,aqq3,afac
       real*4 vmax,amaxf,aminy,amaxy,xz,th,vq,vsl,vv,stepq
       real*4 polx,polz,pqPx(n1),pqPz(n1),pqSx(n1),pqSz(n1)
       real*4 alp1x(n1),alp1z(n1),alp2x(n1),alp2z(n1)
       real*4 alp3x(n1),alp3z(n1),t1(n1),t2(n1)
       dimension alam(10),am(10),r(10),akd(10),aks(10),qd(10),qs(10)
       dimension cd(10),cs(10),p(10),vp(10),vs(10)
       complex*16 am11,am12,am13,am33,am55,am66,amd(10),ams(10)
       complex*16 cero,ai,uno
       complex*16 am1,am2,am3,am4,am23,am44,am22
       complex*16 v1,v2,v3,vv1,vv2,vv1h,vv2h,aa,amd1,amd2,ams1,ams2
       complex*16 bb1,bb2,e1,e2,d,em
       complex*16 al(10),amu(10),e(10)
       complex*16 eps11,eps33,p13
c
       open(2,file='XZplane.dat')
       open(3,file='YZplane.dat')
       open(4,file='XYplane.dat')
       pi=3.141592653589793d0
c
       nth=1500
       dth=2.*pi/dfloat(nth-1)
       uno=(1.d0,0.d0)
       cero=(0.d0,0.d0)
       ai=(0.d0,1.d0)  
       rad=180./pi
c icart=0 Cartesian; icart=1 Polar
       icart=1
c
c elastic constants and relaxation times
c
c PHENOLIC (orthorombic) -----------
        c11=11.670e+9
        c12=6.662e+9
        c13=7.008e+9
        c22=15.445e+9
        c23=c13
        c33=17.443e+9
        c44=3.768e+9
        c55=3.518e+9
        c66=3.135e+9
        rho=1364. 
        fi=250000. 
c orthorombic Helbig -----------
        c11=10.e+6
        c12=2.e+6
	    c12=-4.e+6
        c13=1.5e+6
 	    c13=-5.5e+6
        c22=9.e+6
        c23=1.e+6
        c33=8.e+6
        c44=3.e+6
        c55=2.e+6
        c66=1.e+6
        rho=1. 
        fi=250000. 
c Q's are infinite
c change arrow size for polarization
        tep=6.4e-7
        tes1=6.4e-7
        tes2=6.4e-7
        tes3=6.4e-7 
        tsp=tep
        tss1=tes1
        tss2=tes2
        tss3=tes3                                              
c values of max. for axes
        vq=35.  
        vsl=1.
        vv=3.5 
        vat=50.    
c
        D=(c11+c22+c33)/3.
        G=(c44+c55+c66)/3.
        aK=D-4.*G/3.    
       print *,'START GRAPHICS'
c ides=1 and ides1=0 SLOWNESS
c ides=1 and ides1=1 ENERGY VEL
c ides=0 and ides2=0 QUALITY FACTOR
c ides=0 and ides2=1 ATTENUATION FACTOR
c
       print *,'want att.(0), vel.(1)'
       read *,ides    
       if(ides.eq.1)then    
       print *,'want slowness(0) or energy velocities(1) ?'
       read *,ides1
       endif      
       if(ides.eq.0)then    
       print *,'want q.f.(0) or attenuation(1) ?'
       read *,ides2     
       endif
c
c         print *,'frequency '
c         read *,fi  
         om=2.d0*pi*fi   
       do 999 ip=1,3
       iplane=ip-1
c 
       do i=1,nth
       aux(i)=0.
       aux1(i)=0.
       aux2(i)=0.
       aqx(i)=0.
       aqx1(i)=0.
       end do
c
c complex moduli
c
        am1=(uno+ai*om*tep)/(uno+ai*om*tsp)
        am2=(uno+ai*om*tes1)/(uno+ai*om*tss1)
        am3=(uno+ai*om*tes2)/(uno+ai*om*tss2)
        am4=(uno+ai*om*tes3)/(uno+ai*om*tss3)
c 
c complex stiffnesses, these are the pIJ
c
        am11=c11-D+aK*am1+4.*G*am2/3.
        am12=c12-D+2.*G+aK*am1-2.*G*am2/3.
        am13=c13-D+2.*G+aK*am1-2.*G*am2/3.
        am22=c22-D+aK*am1+4.*G*am2/3.
        am23=c23-D+2.*G+aK*am1-2.*G*am2/3.
        am33=c33-D+aK*am1+4.*G*am2/3.
        am44=c44*am2
        am55=c55*am3
        am66=c66*am4 
c 
c       go to 222
        f9=1.e+9
        am11=(22.,0.55)*f9 
        am22=(24.33,0.084)*f9 
        am33=(6.4,0.32)*f9
        am44=(2.87,0.)*f9
        am55=(2.45,0.08)*f9
        am66=(9.60,0.3)*f9
        am12=(1.7,0.1)*f9
        am13=(0.59,0.2)*f9
        am23=(0.65,0.016)*f9
        rho=2113.
c
        rho=2082.99d0
c        am11=(36087266533.932739,469759649.58541417)
        am11=(36087266533.932739,469759649.58541417)
        am22=am11 
        am33=(29299004828.860,2245409691.407)
        am55=(13900498257.450,0.0)
        am44=am55
        am66=(13907612660.850,-3826993.103) 
        am12=am11-2.*am66
c p13
c        eps11=(0.00000514287433651,-0.00000182652051442) ! 40x40
c        eps33=(0.00000500442318118,-0.00000249027136387)
         eps11=(0.00000409844424857,-0.00000355707808426) ! 80x80
         eps33=(0.00000269022777699,-0.00000483363910893) 
        am13=(eps11*am11-eps33*am33)/(eps11-eps33)
        am23=am13
        write(6,*)'p13',am13
222     continue
c hexagonal
c        am66=(am11-am12)/2.  
*
*       Theta loop
*
        do 1 i=1,nth
        theta=(pi/2.d0)*float(nth-i)/float(nth-1)
        theta=(2.d0*pi)*float(nth-i)/float(nth-1)
        ang=rad*theta
c       if(i.eq.nth) theta=1.d-6
c       if(i.eq.1) theta=pi/2.d0-1.d-6
*
       s=dsin(theta)
       c=dcos(theta)
       c2=c*c
       s2=s*s
       sc2=s2*c2
*
*      Slowness
*      --------
*
       if(iplane.eq.0) then
       em=((am55-am11)*s*s+(am33-am55)*c*c)**2+4.d0*(am13+am55)*
     .     (am13+am55)*s*s*c*c
       em=(-(am11-am55)*s*s+(am33-am55)*c*c)**2+4.d0*(am13+am55)*
     .     (am13+am55)*s*s*c*c
       em=cdsqrt(em)
       v1=cdsqrt(am55+am11*s*s+am33*c*c+em)/sqrt(2.d0*rho)
       v2=cdsqrt(am55+am11*s*s+am33*c*c-em)/sqrt(2.d0*rho)
       v3=cdsqrt((am66*s2+am44*c2)/rho) 
       endif
c
       if(iplane.eq.1) then
       em=((am44-am22)*s*s+(am33-am44)*c*c)**2+4.d0*(am23+am44)*
     .     (am23+am44)*s*s*c*c
       em=cdsqrt(em)
       v1=cdsqrt(am44+am22*s*s+am33*c*c+em)/sqrt(2.d0*rho)
       v2=cdsqrt(am44+am22*s*s+am33*c*c-em)/sqrt(2.d0*rho)
       v3=cdsqrt((am66*s2+am55*c2)/rho) 
       endif
c
       if(iplane.eq.2) then
       em=((am66-am11)*s2+(am22-am66)*c2)**2+4.d0*(am12+am66)*
     .     (am12+am66)*s2*c2
       em=cdsqrt(em)
       v1=cdsqrt(am66+am11*s2+am22*c2+em)/sqrt(2.d0*rho)
       v2=cdsqrt(am66+am11*s2+am22*c2-em)/sqrt(2.d0*rho)
       v3=cdsqrt((am55*s2+am44*c2)/rho) 
       endif
c
       c1=1./real(1.d0/v1)  
       cc2=1./real(1.d0/v2)
       c3=1./real(1.d0/v3)
c         print *,'slowness ',c1,cc2,c3
c
       c1x(i)=1000.*real(s/v1)
       c1z(i)=1000.*real(c/v1) 
       c2x(i)=1000.*real(s/v2)
       c2z(i)=1000.*real(c/v2) 
       c3x(i)=1000.*real(s/v3)
       c3z(i)=1000.*real(c/v3) 
*
*      Energy velocity
*      ---------------
*     
c ----------- XZ-plane ------------------------------------
c
       if(iplane.eq.0) then
       vv1=am11*s2+am55*c2-rho*v1*v1
       vv2=am11*s2+am55*c2-rho*v2*v2
*
       vv1h=-vv1/(am13+am55)
       vv2h=-vv2/(am13+am55)
*
*      qP
*      ---
*
       bb1=vv1h/c/s
       abb1=cdabs(bb1)**2
       de11=rho*(1.d0+abb1)*real(v1)
       c1ex(i)=sngl(c1*real((am11*s+am13*bb1*c+am55*(conjg(bb1)
     .          *c+abb1*s))/v1)/de11)/1000.
       c1ez(i)=sngl(c1*real((am33*c*abb1+am13*conjg(bb1)*s+am55*(c+
     .          bb1*s))/v1)/de11)/1000.
c         print *,'qP ',sqrt(c1ex(i)*c1ex(i)+c1ez(i)*c1ez(i)) 
* 
c polarization
c 
       polx=1./sqrt(1.+real(bb1)*real(bb1))
       polz=real(bb1)/sqrt(1.+real(bb1)*real(bb1)) 
       pqPx(i)=c1ex(i)+polx*.4
       pqPz(i)=c1ez(i)+polz*.4   
c       print *,'polarization qP ',theta*180./pi,polx,polz
c
*
*      qS
*      --
*
       bb2=vv2h/c/s
       abb2=cdabs(bb2)**2
       de22=rho*(1.d0+abb2)*real(v2)
       c2ex(i)=sngl(cc2*real((am11*s+am13*bb2*c+am55*(conjg(bb2)
     .          *c+abb2*s))/v2)/de22)/1000.
       c2ez(i)=sngl(cc2*real((am33*c*abb2+am13*conjg(bb2)*s+am55*(c+
     .          bb2*s))/v2)/de22)/1000.
c         print *,'qS ',sqrt(c2ex(i)*c2ex(i)+c2ez(i)*c2ez(i))
*
c polarization
c 
       polx=1./sqrt(1.+real(bb2)*real(bb2))
       polz=real(bb2)/sqrt(1.+real(bb2)*real(bb2))
       pqSx(i)=c2ex(i)+polx*.4
       pqSz(i)=c2ez(i)+polz*.4   
c       print *,'polarization qS ',theta*180./pi,polx,polz  
c orthogonality test
c       print *,'orthog. ',real(bb2),-1./real(bb1) 
*
*      SH
*      --
*
       c3ex(i)=sngl(c3*real(s*am66/v3)/rho/real(v3))/1000.
       c3ez(i)=sngl(c3*real(c*am44/v3)/rho/real(v3))/1000.
c         print *,'SH ',sqrt(c3ex(i)*c3ex(i)+c3ez(i)*c3ez(i))
*
c ides=1 and ides1=0 SLOWNESS
c ides=1 and ides1=1 ENERGY VEL
c ides=0 and ides2=0 QUALITY FACTOR
c ides=0 and ides2=1 ATTENUATION FACTOR
       if(ides.eq.1.and.ides1.eq.0) then
       if(icart.eq.1) then
       write(2,*)c1x(i),c1z(i),c2x(i),c2z(i),c3x(i),c3z(i)
       endif
       an1=rad*atan(c1z(i)/c1x(i))
       an2=rad*atan(c2z(i)/c2x(i))
       an3=rad*atan(c3z(i)/c3x(i))
       en1=sqrt(c1x(i)*c1x(i)+c1z(i)*c1z(i))
       en2=sqrt(c2x(i)*c2x(i)+c2z(i)*c2z(i))
       en3=sqrt(c3x(i)*c3x(i)+c3z(i)*c3z(i))
       if(icart.eq.0) then
       write(2,*)an1,en1,an2,en2,an3,en3
       endif
       endif
       if(ides.eq.1.and.ides1.eq.1) then
       if(icart.eq.1) then
       write(2,*)c1ex(i),c1ez(i),c2ex(i),c2ez(i),c3ex(i),c3ez(i)
       endif
       an1=rad*atan(c1ez(i)/c1ex(i))
       an2=rad*atan(c2ez(i)/c2ex(i))
       an3=rad*atan(c3ez(i)/c3ex(i))
       en1=sqrt(c1ex(i)*c1ex(i)+c1ez(i)*c1ez(i))
       en2=sqrt(c2ex(i)*c2ex(i)+c2ez(i)*c2ez(i))
       en3=sqrt(c3ex(i)*c3ex(i)+c3ez(i)*c3ez(i))
       if(icart.eq.0) then
       write(2,*)an1,en1,an2,en2,an3,en3
       endif
       endif
c
       endif 
c write XZ
c
c ----------- YZ-plane ------------------------------------
c
       if(iplane.eq.1) then
       vv1=am22*s2+am44*c2-rho*v1*v1
       vv2=am22*s2+am44*c2-rho*v2*v2
*
       vv1h=-vv1/(am23+am44)
       vv2h=-vv2/(am23+am44)  
*
*      qP
*      ---
*
       bb1=vv1h/c/s
       abb1=cdabs(bb1)**2
       de11=rho*(1.d0+abb1)*real(v1)
       c1ex(i)=sngl(c1*real((am22*s+am23*bb1*c+am44*(conjg(bb1)
     .          *c+abb1*s))/v1)/de11)/1000.
       c1ez(i)=sngl(c1*real((am33*c*abb1+am23*conjg(bb1)*s+am44*(c+
     .          bb1*s))/v1)/de11)/1000.
c         print *,'qP ',sqrt(c1ex(i)*c1ex(i)+c1ez(i)*c1ez(i)) 
* 
c polarization
c 
       polx=1./sqrt(1.+real(bb1)*real(bb1))
       polz=real(bb1)/sqrt(1.+real(bb1)*real(bb1)) 
       pqPx(i)=c1ex(i)+polx*.4
       pqPz(i)=c1ez(i)+polz*.4   
c       print *,'polarization qP ',theta*180./pi,polx,polz
c
*
*      qS
*      --
*
       bb2=vv2h/c/s
       abb2=cdabs(bb2)**2
       de22=rho*(1.d0+abb2)*real(v2)
       c2ex(i)=sngl(cc2*real((am22*s+am23*bb2*c+am44*(conjg(bb2)
     .          *c+abb2*s))/v2)/de22)/1000.
       c2ez(i)=sngl(cc2*real((am33*c*abb2+am23*conjg(bb2)*s+am44*(c+
     .          bb2*s))/v2)/de22)/1000.
c         print *,'qS ',sqrt(c2ex(i)*c2ex(i)+c2ez(i)*c2ez(i))
*
c polarization
c 
       polx=1./sqrt(1.+real(bb2)*real(bb2))
       polz=real(bb2)/sqrt(1.+real(bb2)*real(bb2))
       pqSx(i)=c2ex(i)+polx*.4
       pqSz(i)=c2ez(i)+polz*.4   
c       print *,'polarization qS ',theta*180./pi,polx,polz  
c orthogonality test
c       print *,'orthog. ',real(bb2),-1./real(bb1) 
*
*      SH
*      --
*
       c3ex(i)=sngl(c3*real(s*am66/v3)/rho/real(v3))/1000.
       c3ez(i)=sngl(c3*real(c*am55/v3)/rho/real(v3))/1000.
c         print *,'SH ',sqrt(c3ex(i)*c3ex(i)+c3ez(i)*c3ez(i))
*
c ides=1 and ides1=0 SLOWNESS
c ides=1 and ides1=1 ENERGY VEL
c ides=0 and ides2=0 QUALITY FACTOR
c ides=0 and ides2=1 ATTENUATION FACTOR
       if(ides.eq.1.and.ides1.eq.0) then
       if(icart.eq.1) then
       write(3,*)c1x(i),c1z(i),c2x(i),c2z(i),c3x(i),c3z(i)
       endif
       an1=rad*atan(c1z(i)/c1x(i))
       an2=rad*atan(c2z(i)/c2x(i))
       an3=rad*atan(c3z(i)/c3x(i))
       en1=sqrt(c1x(i)*c1x(i)+c1z(i)*c1z(i))
       en2=sqrt(c2x(i)*c2x(i)+c2z(i)*c2z(i))
       en3=sqrt(c3x(i)*c3x(i)+c3z(i)*c3z(i))
       if(icart.eq.0) then
       write(3,*)an1,en1,an2,en2,an3,en3
       endif
       endif
       if(ides.eq.1.and.ides1.eq.1) then
       if(icart.eq.1) then
       write(3,*)c1ex(i),c1ez(i),c2ex(i),c2ez(i),c3ex(i),c3ez(i)
       endif
       an1=rad*atan(c1ez(i)/c1ex(i))
       an2=rad*atan(c2ez(i)/c2ex(i))
       an3=rad*atan(c3ez(i)/c3ex(i))
       en1=sqrt(c1ex(i)*c1ex(i)+c1ez(i)*c1ez(i))
       en2=sqrt(c2ex(i)*c2ex(i)+c2ez(i)*c2ez(i))
       en3=sqrt(c3ex(i)*c3ex(i)+c3ez(i)*c3ez(i))
       if(icart.eq.0) then
       write(3,*)an1,en1,an2,en2,an3,en3
       endif
       endif
c
       endif                                                             
c
c ----------- XY-plane ------------------------------------
c
       if(iplane.eq.2) then
       vv1=am11*s2+am66*c2-rho*v1*v1
       vv2=am11*s2+am66*c2-rho*v2*v2
*
       vv1h=-vv1/(am12+am66)
       vv2h=-vv2/(am12+am66)
*
*      qP
*      ---
*
       bb1=vv1h/c/s
       abb1=cdabs(bb1)**2
       de11=rho*(1.d0+abb1)*real(v1)
       c1ex(i)=sngl(c1*real((am11*s+am12*bb1*c+am66*(conjg(bb1)
     .          *c+abb1*s))/v1)/de11)/1000.
       c1ez(i)=sngl(c1*real((am22*c*abb1+am12*conjg(bb1)*s+am66*(c+
     .          bb1*s))/v1)/de11)/1000.
c         print *,'qP ',sqrt(c1ex(i)*c1ex(i)+c1ez(i)*c1ez(i)) 
* 
c polarization
c 
       polx=1./sqrt(1.+real(bb1)*real(bb1))
       polz=real(bb1)/sqrt(1.+real(bb1)*real(bb1)) 
       pqPx(i)=c1ex(i)+polx*.4
       pqPz(i)=c1ez(i)+polz*.4   
c       print *,'polarization qP ',theta*180./pi,polx,polz
c
*
*      qS
*      --
*
       bb2=vv2h/c/s
       abb2=cdabs(bb2)**2
       de22=rho*(1.d0+abb2)*real(v2)
       c2ex(i)=sngl(cc2*real((am11*s+am12*bb2*c+am66*(conjg(bb2)
     .          *c+abb2*s))/v2)/de22)/1000.
       c2ez(i)=sngl(cc2*real((am22*c*abb2+am12*conjg(bb2)*s+am66*(c+
     .          bb2*s))/v2)/de22)/1000.
c         print *,'qS ',sqrt(c2ex(i)*c2ex(i)+c2ez(i)*c2ez(i))
*
c polarization
c 
       polx=1./sqrt(1.+real(bb2)*real(bb2))
       polz=real(bb2)/sqrt(1.+real(bb2)*real(bb2))
       pqSx(i)=c2ex(i)+polx*.4
       pqSz(i)=c2ez(i)+polz*.4   
c       print *,'polarization qS ',theta*180./pi,polx,polz  
c orthogonality test
c       print *,'orthog. ',real(bb2),-1./real(bb1) 
*
*      SH
*      --
*
       c3ex(i)=sngl(c3*real(s*am55/v3)/rho/real(v3))/1000.
       c3ez(i)=sngl(c3*real(c*am44/v3)/rho/real(v3))/1000.
c         print *,'SH ',sqrt(c3ex(i)*c3ex(i)+c3ez(i)*c3ez(i))
*
c ides=1 and ides1=0 SLOWNESS
c ides=1 and ides1=1 ENERGY VEL
c ides=0 and ides2=0 QUALITY FACTOR
c ides=0 and ides2=1 ATTENUATION FACTOR
       if(ides.eq.1.and.ides1.eq.0) then
       if(icart.eq.1) then
       write(4,*)c1x(i),c1z(i),c2x(i),c2z(i),c3x(i),c3z(i)
       endif
       an1=rad*atan(c1z(i)/c1x(i))
       an2=rad*atan(c2z(i)/c2x(i))
       an3=rad*atan(c3z(i)/c3x(i))
       en1=sqrt(c1x(i)*c1x(i)+c1z(i)*c1z(i))
       en2=sqrt(c2x(i)*c2x(i)+c2z(i)*c2z(i))
       en3=sqrt(c3x(i)*c3x(i)+c3z(i)*c3z(i))
       if(icart.eq.0) then
       write(4,*)an1,en1,an2,en2,an3,en3
       endif
       endif
       if(ides.eq.1.and.ides1.eq.1) then
       if(icart.eq.1) then
       write(4,*)c1ex(i),c1ez(i),c2ex(i),c2ez(i),c3ex(i),c3ez(i)
       endif
       an1=rad*atan(c1ez(i)/c1ex(i))
       an2=rad*atan(c2ez(i)/c2ex(i))
       an3=rad*atan(c3ez(i)/c3ex(i))
       en1=sqrt(c1ex(i)*c1ex(i)+c1ez(i)*c1ez(i))
       en2=sqrt(c2ex(i)*c2ex(i)+c2ez(i)*c2ez(i))
       en3=sqrt(c3ex(i)*c3ex(i)+c3ez(i)*c3ez(i))
       if(icart.eq.0) then
       write(4,*)an1,en1,an2,en2,an3,en3
       endif
       endif
c
       endif                                                             
c
*      Quality factors
*      ---------------
*
       if(om.gt.1.d-6)then
       aqq1=sngl(real(v1*v1)/dimag(v1*v1))
       aqq2=sngl(real(v2*v2)/dimag(v2*v2))
       aqq3=sngl(real(v3*v3)/dimag(v3*v3))
       aqq1=1000./aqq1
       aqq2=1000./aqq2
       aqq3=1000./aqq3
c         print *,'qsss ',aqq2,aqq1,aqq3
c check formula
c
       akap2=real(om/v2)
       gam2=-dimag(om/v2) 
       qq2=(akap2**2-gam2**2)/(2.*akap2*gam2)
c       print *,qq2,aqq2
*
       qf1x(i)=aqq1*s
       qf1z(i)=aqq1*c
       qf2x(i)=aqq2*s
       qf2z(i)=aqq2*c
       qf3x(i)=aqq3*s
       qf3z(i)=aqq3*c 
c 1/km 
       alp1=-om*dimag(1./v1)*1000.
       alp2=-om*dimag(1./v2)*1000.
       alp3=-om*dimag(1./v3)*1000. 
c 1/m
       alp1=-om*dimag(1./v1)
       alp2=-om*dimag(1./v2)
       alp3=-om*dimag(1./v3) 
c check 
c       alp1=(sqrt(aqq1*aqq1+1.)-aqq1)*real(om/v1)
c       alp2=(sqrt(aqq2*aqq2+1.)-aqq2)*real(om/v2)
c       alp3=(sqrt(aqq3*aqq3+1.)-aqq3)*real(om/v3)
c           print *,'alp1 ',alp1
c           print *,'alp2 ',alp2
c           print *,'alp3 ',alp3
c
       alp1x(i)=alp1*s
       alp1z(i)=alp1*c
       alp2x(i)=alp2*s
       alp2z(i)=alp2*c   
c this is to treat the big lobe in TeO2, eliminate outer graphics
c see also thickness of line in XY plane (attenuation curve).
c        if(alp2x(i).gt.8..or.alp2z(i).gt.8.) then
c        alp2x(i)=8.
c        alp2z(i)=8.
c        endif
       alp3x(i)=alp3*s
       alp3z(i)=alp3*c
c--------------
       if(iplane.eq.0) then
c ides=0 and ides2=0 QUALITY FACTOR
c ides=0 and ides2=1 ATTENUATION FACTOR
       if(ides.eq.0.and.ides2.eq.0) then
        if(icart.eq.1) then
        write(2,*)qf1x(i),qf1z(i),qf2x(i),qf2z(i),qf3x(i),qf3z(i)
        endif
        if(icart.eq.0) then
        write(2,*)ang,aqq1,ang,aqq2,ang,aqq3
        endif
       endif
c
       if(ides.eq.0.and.ides2.eq.1) then
        if(icart.eq.1) then
        write(2,*)alp1x(i),alp1z(i),alp2x(i),alp2z(i),alp3x(i),alp3z(i)
        endif
        if(icart.eq.0) then
        write(2,*)ang,alp1,ang,alp2,ang,alp3
        endif
       endif
c
       endif
c -----------------------------------
       if(iplane.eq.1) then
c ides=0 and ides2=0 QUALITY FACTOR
c ides=0 and ides2=1 ATTENUATION FACTOR
       if(ides.eq.0.and.ides2.eq.0) then
        if(icart.eq.1) then
        write(3,*)qf1x(i),qf1z(i),qf2x(i),qf2z(i),qf3x(i),qf3z(i)
        endif
        if(icart.eq.0) then
        write(3,*)ang,aqq1,ang,aqq2,ang,aqq3
        endif
       endif
c
       if(ides.eq.0.and.ides2.eq.1) then
        if(icart.eq.1) then
        write(3,*)alp1x(i),alp1z(i),alp2x(i),alp2z(i),alp3x(i),alp3z(i)
        endif
        if(icart.eq.0) then
        write(3,*)ang,alp1,ang,alp2,ang,alp3
        endif
       endif
c
       endif
c
       if(iplane.eq.2) then
c ides=0 and ides2=0 QUALITY FACTOR
c ides=0 and ides2=1 ATTENUATION FACTOR
       if(ides.eq.0.and.ides2.eq.0) then
        if(icart.eq.1) then
        write(4,*)qf1x(i),qf1z(i),qf2x(i),qf2z(i),qf3x(i),qf3z(i)
        endif
        if(icart.eq.0) then
        write(4,*)ang,aqq1,ang,aqq2,ang,aqq3
        endif
       endif
       if(ides.eq.0.and.ides2.eq.1) then
        if(icart.eq.1) then
        write(4,*)alp1x(i),alp1z(i),alp2x(i),alp2z(i),alp3x(i),alp3z(i)
        endif
        if(icart.eq.0) then
        write(4,*)ang,alp1,ang,alp2,ang,alp3
        endif
       endif
c
       endif
c--------------          
       if(ides2.eq.0)then
c polarization  in q.f
c 
       if(ides.eq.0)then  
       afac=vq/12.
       polx=1./sqrt(1.+real(bb1)*real(bb1))
       polz=real(bb1)/sqrt(1.+real(bb1)*real(bb1)) 
       pqPx(i)=qf1x(i)+polx*afac
       pqPz(i)=qf1z(i)+polz*afac   
       polx=1./sqrt(1.+real(bb2)*real(bb2))
       polz=real(bb2)/sqrt(1.+real(bb2)*real(bb2))
       pqSx(i)=qf2x(i)+polx*afac
       pqSz(i)=qf2z(i)+polz*afac
       endif             
       else
c polarization  in att.
c 
       if(ides.eq.0)then  
       afac=0.8
       polx=1./sqrt(1.+real(bb1)*real(bb1))
       polz=real(bb1)/sqrt(1.+real(bb1)*real(bb1)) 
       pqPx(i)=alp1x(i)+polx*afac
       pqPz(i)=alp1z(i)+polz*afac   
       polx=1./sqrt(1.+real(bb2)*real(bb2))
       polz=real(bb2)/sqrt(1.+real(bb2)*real(bb2))
       pqSx(i)=alp2x(i)+polx*afac
       pqSz(i)=alp2z(i)+polz*afac
       endif             

       endif
       endif
*
1       continue
*
10      continue
999     continue
*
        STOP                                                            GTR00750
        END                                                             GTR00760
C                                                                       GTR00780

